/* K. Lemmens May 1996 */

#include <time.h>
#include <msql.h>
#include <forms.h>

/*
#define FORMS081  TRUE
*/

#define MSQL2     TRUE

#include "Xsql.h"

#define MAXSTRING 1000
#define MAXQUERY  2048
#define MAXLOGINFO  25   /* maximum number of lines in info log window */

/* browser initial fontsize : */
#define FONTSIZE  12.0

#ifdef __hpux
#define PRINTCMD "lp"
#else
#define PRINTCMD "lpr"
#endif

#define min(a,b) (a > b ? b : a )

#define debug printf

#define SELECT "SELECT * FROM %s "
#define INSERT "INSERT INTO %s VALUES ("
#define UPDATE "UPDATE %s SET "
#define DELETE "DELETE FROM %s "
#define WHERE  " WHERE "
#define EQUAL  "%s = %s"
#define LIKE   "%s LIKE %s" 
#define AND    " AND "
#define ORDER  "ORDER BY %s "

#define PASSIVE  0
#define ACTIVE   1
#define KEYFIELD 2

#define COUNT    0
#define NOCOUNT  1

typedef struct {
   char     *Table;
   int      Numflds;
   int      Allflds; /* including all indexes (MSQL 2.0) */
   int      Primkey; /* number of primary key field */
   m_field  *Fields;
   FD_Xsql  *Xsql; /* to make main form available to subfunctions */
   m_result *Res;  /* hook for Browser to hold a selection */
} Info_t;
   
/* Global variables */

extern int sock;  /* selected database handle */
extern int countflag;

/* function prototypes */

/* XsqlHelpers.c */

int  GetPrimaryKey(Info_t *I);
void SetNewServer(char *server,FD_Xsql *fd_Xsql);
void SetNewDatabase(char *database,FD_Xsql *fd_Xsql);
void SetNewTable(char *table,FD_Xsql *fd_Xsql);
char *TypeConvert(char *target,const char *string, int fieldtype);
int  CheckTableSelected(FD_Xsql *fd_Xsql);
Info_t *CopyInfoStruct(Info_t *Source);
void FreeInfoStruct(Info_t *Source);
int  ExecuteQuery(Info_t *I,char *query);

/* Shower functions : */

FD_Shower *BuildShowerForm(Info_t *I, char *title, int mode);
void WriteToBrowser(Info_t *I,FL_OBJECT *ob,m_row row);

/* XsqlDialog.c */
void SqlError(char *s,...);
void Message(char *s,...);
void Info(FD_Xsql *fd_Xsql,char *s,...);

/* ShowFields.c */
void SetPrimaryKey(FL_OBJECT *ob, long parent);
int GetPrimaryKey(Info_t *I);
